package com.glxp.udi.admin.controller.udidl;

import com.glxp.udi.admin.req.udidl.EnterpriseRequest;
import com.glxp.udi.admin.res.udidl.EnterpriseResponse;
import com.glxp.udi.admin.service.udidl.EnterpriseService;
import com.glxp.udi.common.enums.ResultEnum;
import com.glxp.udi.common.res.BaseResponse;
import com.glxp.udi.common.util.ResultVOUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 企业信息控制器
 */
@RestController
public class EnterpriseController {

    @Autowired
    private EnterpriseService enterpriseService;

    /**
     * 用户注册页面，根据企业类型，从阳光采购平台查询企业名称
     *
     * @param enterpriseRequest
     * @param bindingResult
     * @return
     */
    @GetMapping("/udiwms/enterprise/filterCandidateCompanyName")
    public BaseResponse filterCandidateCompanyName(EnterpriseRequest enterpriseRequest, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }
        List<EnterpriseResponse> enterpriseResponses = enterpriseService.filterCandidateCompanyName(enterpriseRequest);
        return ResultVOUtils.success(enterpriseResponses);
    }

}
