package com.glxp.udi.admin.controller.udidl;

import com.glxp.udi.admin.req.udidl.SysRoleParam;
import com.glxp.udi.admin.service.udidl.SysRoleService;
import com.glxp.udi.common.enums.ResultEnum;
import com.glxp.udi.common.res.BaseResponse;
import com.glxp.udi.common.util.ResultVOUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;


@RestController
public class SysRoleController {

    @Autowired
    private SysRoleService sysRoleService;

    /**
     * 查询角色列表
     *
     * @param sysRoleParam
     * @param bindingResult
     * @return
     */
    @PostMapping("/sys/role/list")
    public BaseResponse list(@RequestBody SysRoleParam sysRoleParam, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL);
        }
        return sysRoleService.getList(sysRoleParam);
    }

}
