package com.glxp.udi.admin.controller.udidl;

import com.glxp.udi.admin.req.udidl.SysUserParam;
import com.glxp.udi.admin.service.udidl.SysUserService;
import com.glxp.udi.common.enums.ResultEnum;
import com.glxp.udi.common.res.BaseResponse;
import com.glxp.udi.common.util.ResultVOUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * 系统管理 - 用户管理功能接口
 */
@Slf4j
@RestController
public class SysUserController {

    @Autowired
    private SysUserService sysUserService;

    /**
     * 查询用户列表
     *
     * @param sysUserParam
     * @return
     */
    @PostMapping("/sys/user/list")
    public BaseResponse list(@RequestBody SysUserParam sysUserParam, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL);
        }
        return sysUserService.getList(sysUserParam);
    }


}
