package com.glxp.udi.admin.dao.auth;

import com.glxp.udi.admin.entity.auth.AuthLicense;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface AuthLicenseDao {

    AuthLicense get(String id);

    int save(AuthLicense authLicense);

    int update(AuthLicense authLicense);

    int remove(String appid);

    int romveByCustomerId(String customerId);

    /**
     * 根据名称查询授权码和秘钥
     *
     * @param name
     * @return
     */
    AuthLicense selectLicenseByName(@Param("name") String name);

    /**
     * 根据名称修改系统的授权码和秘钥
     *
     * @param licenseApikey
     * @param secretkey
     * @param name
     */
    void updateLicenseByName(@Param("apikey") String licenseApikey, @Param("secretkey") String secretkey, @Param("name") String name);
}
