package com.glxp.udi.admin.dao.basic;

import com.glxp.udi.admin.entity.basic.BussinessTypeEntity;
import com.glxp.udi.admin.req.basic.BussinessTypeFilterRequest;
import com.glxp.udi.admin.res.basic.BussinessTypResponse;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface BussinessTypeDao {
    BussinessTypeEntity selectById(String id);

    List<BussinessTypeEntity> filterList(BussinessTypeFilterRequest bussinessTypeFilterRequest);

    List<BussinessTypResponse> filterJoinList(BussinessTypeFilterRequest bussinessTypeFilterRequest);

    List<BussinessTypeEntity> filterAllByUser(BussinessTypeFilterRequest bussinessTypeFilterRequest);

    boolean insertBussinessType(BussinessTypeEntity bussinessTypeEntity);

    boolean insertIgnoreBussinessType(BussinessTypeEntity bussinessTypeEntity);

    boolean updateBussinessType(BussinessTypeEntity bussinessTypeEntity);

    boolean deleteById(@Param("id") String id);

    BussinessTypeEntity selectByAction(String action);

    /**
     * 查询是否启用补单
     *
     * @param billNo
     * @return
     */
    String selectEnableSupplementOrder(String billNo);

    /**
     * 查询候选补单类型
     *
     * @param mainAction
     * @return
     */
    List<BussinessTypeEntity> selectCandidateBussinsessTypes(String mainAction);

    /**
     * 更新对应单据类型的补单数据
     *
     * @param supplementOrderType
     * @param action
     */
    void updateSupplementOrderType(@Param("supplementOrderType") String supplementOrderType, @Param("action") String action);
}
