package com.glxp.udi.admin.dao.inout;

import com.glxp.udi.admin.entity.inout.WarehouseEntity;
import com.glxp.udi.admin.req.inout.WarehouseQueryRequest;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface CodesDao {

    WarehouseEntity getByCorpOrderId(String corpOrderId);

    List<WarehouseEntity> listWarehouse(WarehouseQueryRequest warehouseQueryRequest);

    boolean insertWarehouse(WarehouseEntity warehouseEntity);

    boolean insertWarehouses(@Param("io_codesEntities") List<WarehouseEntity> warehouseEntities);

    List<WarehouseEntity> findByNo(WarehouseQueryRequest warehouseQueryRequest);

    Integer isExit(WarehouseEntity warehouseEntity);

    List<WarehouseEntity> findByOrderId(WarehouseQueryRequest warehouseQueryRequest);

    List<WarehouseEntity> findByReceiptId(@Param("orderId") String orderId);

    boolean deleteByOrderId(@Param("orderId") String orderId);


    List<WarehouseEntity> findByCode(@Param("code") String code);

    List<WarehouseEntity> searchCode(@Param("code") String code);

    boolean updateOrderId(@Param("oldOrderId") String oldOrderId, @Param("newOrderId") String newOrderId);

    boolean updateUnit(@Param("orderId") String orderId, @Param("fromCorpId") String fromCorpId, @Param("fromCorp") String fromCorp);

    List<String> findCodesById(@Param("orderId") String orderId);

    boolean updateCode(WarehouseEntity warehouseEntity);

    boolean updateRelId(@Param("relId") String relId, @Param("nameCode") String nameCode, @Param("orderId") String orderId);

    boolean updateSupId(@Param("supId") String supId, @Param("nameCode") String nameCode, @Param("orderId") String orderId);


}
