package com.glxp.udi.admin.dao.inout;

import com.glxp.udi.admin.entity.inout.StockOrderEntity;
import com.glxp.udi.admin.entity.inout.StockOrderPrintEntity;
import com.glxp.udi.admin.req.inout.StockOrderFilterRequest;
import com.glxp.udi.admin.req.inout.StockOrderQueryRequest;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface StockOrderDao {

    List<StockOrderEntity> listStockOrder(StockOrderQueryRequest stockOrderQueryRequest);

    List<StockOrderEntity> listStockOrderNoDealWith(StockOrderQueryRequest stockOrderQueryRequest);

    boolean insertStockOrder(StockOrderEntity stockOrderEntity);

    boolean updateById(StockOrderEntity stockOrderEntity);

    boolean deleteByOrderId(@Param("orderId") String orderId);

    boolean deleteById(@Param("id") String id);

    boolean updateByStatus(@Param("orderId") String orderId, @Param("status") Integer status);

    List<StockOrderEntity> filterListOr(StockOrderFilterRequest stockOrderFilterRequest);

    StockOrderEntity findOne(StockOrderFilterRequest stockOrderFilterRequest);

    List<StockOrderPrintEntity> listOrderPrint(StockOrderFilterRequest stockOrderFilterRequest);

    void updateSupplementNoByBillNo(@Param("billNo") String billNo, @Param("supplementOrderNo") String supplementOrderNo);

    /**
     * 查询补单单号为空的单据号
     *
     * @return
     */
    List<StockOrderEntity> selectSupplementOrderList();

}
