package com.glxp.udi.admin.dao.inventory;

import com.glxp.udi.admin.entity.inventory.InvWarehouseEntity;
import com.glxp.udi.admin.req.inventory.FilterInvWarehouseRequest;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface InvWarehouseDao {

    List<InvWarehouseEntity> filterInvWarehouse(FilterInvWarehouseRequest filterInvWarehouseRequest);

    List<InvWarehouseEntity> filterAllByUser(FilterInvWarehouseRequest filterInvWarehouseRequest);

    InvWarehouseEntity selectMaxCode(FilterInvWarehouseRequest filterInvWarehouseRequest);

    List<InvWarehouseEntity> filterGroupInvWarehouse(FilterInvWarehouseRequest filterInvWarehouseRequest);

    boolean insertInvWarehouse(InvWarehouseEntity InvWarehouseEntity);

    boolean updateInvWarehouse(InvWarehouseEntity InvWarehouseEntity);

    InvWarehouseEntity selectById(@Param("id") String id);

    boolean deleteById(@Param("id") String id);

    String getNameByCode(@Param("fromCorpId") String fromCorpId);

    /**
     * 批量导入仓库信息
     *
     * @param invWarehouseEntities
     */
    void importInvWarehouse(@Param("invWarehouseEntities") List<InvWarehouseEntity> invWarehouseEntities);

    /**
     * 更新第三方仓库ID
     *
     * @param id
     * @param thridWarehouseId
     * @param sysId
     * @return
     */
    boolean updateThridId(@Param("id") Integer id, @Param("thridWarehouseId") Integer thridWarehouseId, @Param("sysId") String sysId);
}
