package com.glxp.udi.admin.dao.param;

import com.glxp.udi.admin.entity.param.SystemPDFTemplateRelevanceEntity;
import com.glxp.udi.admin.req.itextpdf.SystemPDFTemplateRelevanceRequest;
import com.glxp.udi.admin.res.param.SystemPDFTemplateRelevanceResponse;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;


@Mapper
public interface SystemPDFTemplateRelevanceDao {


    List<SystemPDFTemplateRelevanceResponse> filterList(SystemPDFTemplateRelevanceRequest systemPDFModuleRequest);

    /**
     * 根据 customerId 查询
     *
     * @param customerId 传入的 customerId
     * @return
     */
    List<SystemPDFTemplateRelevanceEntity> listByCustomerId(Long customerId);

    /**
     * 根据 多个 customerId 查询
     *
     * @param customerIds 传入的 customerIds
     * @return
     */
    List<SystemPDFTemplateRelevanceEntity> listByCustomerIdIn(List<Long> customerIds);

    /**
     * 根据 template_id 查询 customer_id
     *
     * @param templateId 传入的 templateId
     * @return
     */
    List<SystemPDFTemplateRelevanceEntity> listByTemplateId(int templateId);

    /**
     * 批量插入
     *
     * @param systemPDFTemplateRelevanceEntityList
     * @return
     */
    int insertSystemPDFTemplateRelevanceAll(List<SystemPDFTemplateRelevanceEntity> systemPDFTemplateRelevanceEntityList);

    boolean insert(SystemPDFTemplateRelevanceEntity systemPDFTemplateRelevanceEntity);


    /**
     * 根据 customerId 删除
     *
     * @return
     */
    boolean deleteById(Integer id);

    boolean udpateRl(SystemPDFTemplateRelevanceEntity systemPDFTemplateRelevanceEntity);
}
