package com.glxp.udi.admin.service.auth;


import com.glxp.udi.admin.entity.auth.AuthRole;
import com.glxp.udi.admin.entity.basic.BasicBussinessTypeRoleEntity;
import com.glxp.udi.admin.req.auth.AuthRoleQueryRequest;

import java.util.List;

public interface AuthRoleService {

    List<AuthRole> listAdminPage(AuthRoleQueryRequest authRoleQueryRequest);

    List<AuthRole> listAuthAdminRolePage(Integer page, Integer limit, Integer status);

    AuthRole findByName(String name);

    boolean insertAuthRole(AuthRole authRole);

    boolean updateAuthRole(AuthRole authRole);

    List<AuthRole> listCustomerRoles(Integer page, Integer limit, Integer isCustomer);

    List<AuthRole> listAuthRoles2(Integer page, Integer limit);

    boolean deleteById(Long id);

    /**
     * 查询角色扫码单据授权数据
     *
     * @param roleId
     * @return
     */
    List<BasicBussinessTypeRoleEntity> getBussinessTypeRole(Long roleId);

    /**
     * 更新角色扫码单据类型授权数据
     *
     * @param roleId
     * @param actions
     */
    void updateBussinessTypeRole(Long roleId, List<String> actions);
}
