package com.glxp.udi.admin.service.basic.impl;

import cn.hutool.core.util.StrUtil;
import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.constant.TypeConstant;
import com.glxp.udi.admin.dao.basic.BussinessTypeDao;
import com.glxp.udi.admin.entity.basic.BasicThirdSysDetailEntity;
import com.glxp.udi.admin.entity.basic.BussinessTypeEntity;
import com.glxp.udi.admin.req.basic.BussinessTypeFilterRequest;
import com.glxp.udi.admin.res.basic.BussinessTypResponse;
import com.glxp.udi.admin.service.basic.BasicThirdSysDetailService;
import com.glxp.udi.admin.service.basic.BussinessTypeService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BussinessTypeServiceImpl implements BussinessTypeService {

    @Resource
    BussinessTypeDao bussinessTypeDao;
    @Resource
    BasicThirdSysDetailService basicThirdSysDetailService;

    @Override
    public List<BussinessTypeEntity> filterList(BussinessTypeFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessTypeFilterRequest.getPage() != null) {
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BussinessTypeEntity> data = bussinessTypeDao.filterList(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public List<BussinessTypResponse> filterJoinList(BussinessTypeFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessTypeFilterRequest.getPage() != null) {
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BussinessTypResponse> data = bussinessTypeDao.filterJoinList(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public List<BussinessTypeEntity> filterAllByUser(BussinessTypeFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessTypeFilterRequest.getPage() != null) {
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BussinessTypeEntity> data = bussinessTypeDao.filterAllByUser(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public BussinessTypeEntity selectById(String id) {
        return bussinessTypeDao.selectById(
                id
        );
    }

    @Override
    public BussinessTypeEntity findBTByAction(String action) {
        BussinessTypeFilterRequest bussinessTypeFilterRequest = new BussinessTypeFilterRequest();
        bussinessTypeFilterRequest.setAction(action);
        List<BussinessTypeEntity> data = bussinessTypeDao.filterList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public BussinessTypeEntity findBTByName(String action) {
        BussinessTypeFilterRequest bussinessTypeFilterRequest = new BussinessTypeFilterRequest();
        bussinessTypeFilterRequest.setName(action);
        List<BussinessTypeEntity> data = bussinessTypeDao.filterList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public BussinessTypResponse findJoinBTByAction(String action) {
        BussinessTypeFilterRequest bussinessTypeFilterRequest = new BussinessTypeFilterRequest();
        bussinessTypeFilterRequest.setAction(action);
        bussinessTypeFilterRequest.setEnabled(true);
        List<BussinessTypResponse> data = bussinessTypeDao.filterJoinList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public BasicThirdSysDetailEntity findByActionKey(String action, String key) {
        BussinessTypResponse bussinessTypResponse = findJoinBTByAction(action);
        if (bussinessTypResponse != null) {
            BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailService.selectByKey(key, bussinessTypResponse.getThirdSysFk());
            return basicThirdSysDetailEntity;
        }
        return null;
    }

    @Override
    public boolean insertBussinessType(BussinessTypeEntity bussinessTypeEntity) {
        if (!StrUtil.isEmpty(bussinessTypeEntity.getSupplementOrderType())) {
            BussinessTypeEntity correspondType = bussinessTypeDao.selectByAction(bussinessTypeEntity.getSupplementOrderType());
            if (correspondType != null && correspondType.getCorpType() == 1) {
                bussinessTypeDao.updateSupplementOrderType(bussinessTypeEntity.getSupplementOrderType(), bussinessTypeEntity.getAction());
            }
        }
        return bussinessTypeDao.insertBussinessType(bussinessTypeEntity);
    }

    @Override
    public boolean insertIgnoreBussinessType(BussinessTypeEntity bussinessTypeEntity) {
        return bussinessTypeDao.insertIgnoreBussinessType(bussinessTypeEntity);
    }

    @Override
    public boolean updateBussinessType(BussinessTypeEntity bussinessTypeEntity) {
        //更新对应单据类型补单类型

        if (StrUtil.isEmpty(bussinessTypeEntity.getSupplementOrderType())) {
            BussinessTypeEntity temp = bussinessTypeDao.selectByAction(bussinessTypeEntity.getAction());
            BussinessTypeEntity bussinessTypeEntity1 = bussinessTypeDao.selectByAction(temp.getSupplementOrderType());
            if (bussinessTypeEntity1 != null) {
                bussinessTypeEntity1.setSupplementOrderType("");
                bussinessTypeDao.updateBussinessType(bussinessTypeEntity1);
            }

        } else {
            BussinessTypeEntity correspondType = bussinessTypeDao.selectByAction(bussinessTypeEntity.getSupplementOrderType());
            if (correspondType != null && correspondType.getCorpType() == 1) {
                bussinessTypeDao.updateSupplementOrderType(bussinessTypeEntity.getSupplementOrderType(), bussinessTypeEntity.getAction());
            }
        }
        return bussinessTypeDao.updateBussinessType(bussinessTypeEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return bussinessTypeDao.deleteById(id);
    }

    @Override
    public List<BussinessTypeEntity> candidateBussinessType(String mainAction) {
//        BussinessTypeEntity rawData = bussinessTypeDao.selectById(id);
//        String mainAction;
        if (mainAction.equals(TypeConstant.TYPE_OUT)) {
            mainAction = TypeConstant.TYPE_PUT;
        } else {
            mainAction = TypeConstant.TYPE_OUT;
        }
        return bussinessTypeDao.selectCandidateBussinsessTypes(mainAction);
    }
}
