package com.glxp.udi.admin.service.inout;

import com.glxp.udi.admin.entity.inout.OrderEntity;
import com.glxp.udi.admin.entity.inout.StockOrderEntity;
import com.glxp.udi.admin.entity.inout.WarehouseEntity;
import com.glxp.udi.admin.req.inout.OrderFilterRequest;
import com.glxp.udi.admin.req.inout.OrderQueryRequest;
import com.glxp.udi.admin.res.inout.StockOrderResponse;
import com.glxp.udi.common.res.BaseResponse;

import java.util.List;

public interface OrderService {

    List<OrderEntity> listOrders(OrderQueryRequest orderQueryRequest);

    boolean insertOrder(OrderEntity orderEntity);

    boolean updateOrder(OrderEntity orderEntity);

    List<OrderEntity> listOrderError(OrderQueryRequest orderQueryRequest);

    List<OrderEntity> listOrderRepeat(OrderQueryRequest orderQueryRequest);

    boolean deleteByOrderId(String orderId);

    boolean deleteById(String id);

    boolean updateUnit(OrderEntity orderEntity);

    boolean updateOrderStatus(String orderId, Integer status);

    boolean updateExportStatus(String orderId, Integer exportStatus);

    boolean updateSignStatus(String orderId, String signStatus);

    boolean updateContrastStatus(String orderId, String contrastStatus);

    boolean updateRemark(String orderId, String remark);

    List<OrderEntity> findAllOrders(OrderFilterRequest orderFilterRequest);

    List<OrderEntity> filterListOr(OrderFilterRequest orderFilterRequest);

    List<OrderEntity> filterList(OrderFilterRequest orderFilterRequest);

    OrderEntity findOne(OrderFilterRequest orderFilterRequest);

    OrderEntity findById(String orderId);

    List<String> findCodesById(String orderId);

    List<OrderEntity> filterListByOrder(List<String> orderList);

    List<OrderEntity> filterListByCode(List<WarehouseEntity> warehouseEntityList);

    /**
     * 补单
     *
     * @param billNo 单据号
     * @return
     */
    BaseResponse supplementOrder(String billNo, String orderIdFk);

    /**
     * 判断订单是否可以补单
     *
     * @param stockOrderEntityList
     * @return
     */
    List<StockOrderResponse> checkSupplementOrder(List<StockOrderEntity> stockOrderEntityList);
}
