package com.glxp.udi.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.inout.BussinessTypeContrastDao;
import com.glxp.udi.admin.entity.inout.BussinessContrastTypeEntity;
import com.glxp.udi.admin.entity.inout.BussinessTypeEntity;
import com.glxp.udi.admin.req.receipt.BussinessTypeConstrastFilterRequest;
import com.glxp.udi.admin.service.inout.BussinessTypeContrastService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BussinessTypeContrastServiceImpl implements BussinessTypeContrastService {

    @Resource
    BussinessTypeContrastDao bussinessTypeContrastDao;


    @Override
    public List<BussinessContrastTypeEntity> filterList(BussinessTypeConstrastFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessTypeFilterRequest.getPage() != null) {
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BussinessContrastTypeEntity> data = bussinessTypeContrastDao.filterList(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public boolean insertBussinessType(BussinessContrastTypeEntity bussinessTypeEntity) {
        return bussinessTypeContrastDao.insertBussinessType(bussinessTypeEntity);
    }

    @Override
    public boolean updateBussinessType(BussinessContrastTypeEntity bussinessTypeEntity) {
        return bussinessTypeContrastDao.updateBussinessType(bussinessTypeEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return bussinessTypeContrastDao.deleteById(id);
    }
}
