package com.glxp.udi.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.thrsys.ThrCorpDao;
import com.glxp.udi.admin.entity.thrsys.ThrCorpEntity;
import com.glxp.udi.admin.req.thrsys.FilterThrCorpRequest;
import com.glxp.udi.admin.service.thrsys.ThrCorpService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Slf4j
@Service
public class ThrCorpServiceImpl implements ThrCorpService {

    @Resource
    private ThrCorpDao thrCorpDao;

    @Override
    public List<ThrCorpEntity> filterThrCorps(FilterThrCorpRequest filterThrCorpRequest) {
        if (filterThrCorpRequest == null) {
            return Collections.emptyList();
        }
        if (filterThrCorpRequest.getPage() != null) {
            int offset = (filterThrCorpRequest.getPage() - 1) * filterThrCorpRequest.getLimit();
            PageHelper.offsetPage(offset, filterThrCorpRequest.getLimit());
        }
        List<ThrCorpEntity> data = thrCorpDao.filterThrCorps(filterThrCorpRequest);
        return data;
    }

    @Override
    public boolean insertThrCorps(ThrCorpEntity thrCorpEntity) {
        return thrCorpDao.insertThrCorps(thrCorpEntity);
    }

    @Override
    public boolean insertThrCorpss(List<ThrCorpEntity> thrCorpEntitys) {
        return thrCorpDao.insertThrCorpss(thrCorpEntitys);
    }

    @Override
    public boolean updateThrCorps(ThrCorpEntity thrCorpEntity) {
        return thrCorpDao.updateThrCorps(thrCorpEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrCorpDao.deleteById(id);
    }

    @Override
    public boolean deleteByUnitId(String id) {
        return thrCorpDao.deleteByUnitId(id);
    }

    @Override
    public boolean deleteAll() {
        return thrCorpDao.deleteAll();
    }

    @Override
    @Async
    public void importJsonData(List<ThrCorpEntity> thrCorpEntities) {
        try {
            thrCorpDao.importThrCorps(thrCorpEntities);
        } catch (Exception e) {
            log.error("导入第三方往来单位数据异常", e);
        }
    }
}
