package com.glxp.udi.admin.service.udidl.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.glxp.udi.admin.req.feign.BaseParam;
import com.glxp.udi.admin.req.udidl.EnterpriseRequest;
import com.glxp.udi.admin.res.udidl.EnterpriseResponse;
import com.glxp.udi.admin.service.udidl.EnterpriseService;
import com.glxp.udi.admin.util.UdidlClient;
import com.glxp.udi.common.res.BaseResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Slf4j
@Service
public class EnterpriseServiceImpl implements EnterpriseService {

    @Autowired
    private UdidlClient udidlClient;


    @Override
    public List<EnterpriseResponse> filterCandidateCompanyName(EnterpriseRequest enterpriseRequest) {
        BaseParam baseParam = new BaseParam();
        baseParam.setPage(1);
        baseParam.setLimit(10);
        baseParam.setName(enterpriseRequest.getKey());

        List<EnterpriseResponse> data = new ArrayList<>(10);
        if (enterpriseRequest.getBussinessStatus().equals("1")) {
            //生产企业
            BaseResponse manufactureList = udidlClient.getManufactureList(baseParam);
            if (null != manufactureList.getData()) {
                JSONArray list = JSON.parseObject(JSON.toJSONString(manufactureList.getData())).getJSONArray("list");
                for (Object o : list) {
                    JSONObject jsonObject = JSON.parseObject(JSON.toJSONString(o));
                    EnterpriseResponse response = new EnterpriseResponse();
                    response.setName(jsonObject.getString("manufactureName"));
                    data.add(response);
                }
            }
        } else if (enterpriseRequest.getBussinessStatus().equals("2")) {
            //配送企业
            BaseResponse distributorList = udidlClient.getDistributorList(baseParam);
            if (null != distributorList.getData()) {
                JSONArray list = JSON.parseObject(JSON.toJSONString(distributorList.getData())).getJSONArray("list");
                for (Object o : list) {
                    JSONObject jsonObject = JSON.parseObject(JSON.toJSONString(o));
                    EnterpriseResponse response = new EnterpriseResponse();
                    response.setName(jsonObject.getString("distributorName"));
                    data.add(response);
                }
            }
        } else if (enterpriseRequest.getBussinessStatus().equals("3")) {
            //生产企业
            BaseResponse hospitalList = udidlClient.getHospitalList(baseParam);
            if (null != hospitalList.getData()) {
                JSONArray list = JSON.parseObject(JSON.toJSONString(hospitalList.getData())).getJSONArray("list");
                for (Object o : list) {
                    JSONObject jsonObject = JSON.parseObject(JSON.toJSONString(o));
                    EnterpriseResponse response = new EnterpriseResponse();
                    response.setName(jsonObject.getString("purchaseName"));
                    data.add(response);
                }
            }
        }
        return data;
    }
}
